{copyright (c) J. G. Owen 2003}

unit Sbrs;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms,
Controls, Buttons, StdCtrls, ExtCtrls, Dialogs{, Gauges};

const

{these characters should be defined in sbrs.pas because they're
general-purpose ASCII.}

Stx {: char} = chr(2);
Etx {: char} = chr(3);
Eot {: char} = chr(4);
Ack {: char} = chr(6);
Lf  {: char} = chr(10);
Cr  {: char} = chr(13);
{Ff  = chr(12); }
Del {: char} = #127;
ESC = #27;
CTL = $40;
LNEND = CR+LF;

CTLX = chr(ord('X')-CTL);
CTLC = chr(ord('C')-CTL);

crlf : string = CR+LF {chr(13)+chr(10)};

kilobyte = 1024;

  BIT0 =  (1) ;
  BIT1 =  (2) ;
  BIT2 =  (4) ;
  BIT3 =  (8) ;
  BIT4 =  (16) ;
  BIT5 =  (32) ;
  BIT6 =  (64) ;
  BIT7 =  (128) ;
  BIT8 =  (256) ;
  BIT9 =  (512) ;
  BIT10 =  (1024) ;
  BIT11 =  (2048) ;
  BIT12 =  (4096) ;
  BIT13 =  (8192) ;
  BIT14 =  (16384) ;
  BIT15 =  (32768) ;
  BIT16 =  (65536) ;
  BIT17 =  (131072) ;
  BIT18 =  (262144) ;
  BIT19 =  (524288) ;
  BIT20 =  (1048576) ;
  BIT21 =  (2097152) ;
  BIT22 =  (4194304) ;
  BIT23 =  (8388608) ;
  BIT24 =  (16777216) ;
  BIT25 =  (33554432) ;
  BIT26 =  (67108864) ;
  BIT27 =  (134217728) ;
  BIT28 =  (268435456) ;
  BIT29 =  (536870912) ;
  BIT30 =  (1073741824) ;


type
TICKTIME = record
  waitfor,oldcount: longint;
end;

const

{a value to assign to a ticktime variable so that when
delayed is called with it, it will return as time-up.
see at least lcxcomm.}
dzero : TICKTIME = (
  waitfor:0;
  oldcount:0;
);



function position(index:integer; what,s:string):integer;
procedure quickbeep;
function contexthelp(number:integer):boolean;
function helpoid(sHELPJUNK:pchar):boolean;
procedure hglass;
procedure dcursor;
function findhelp(form: Tform):boolean;
procedure fixdirectory;
{ procedure finalsbrs; }
procedure cwdize(var s:string);
function pgmdir:string;
procedure pgmdirize(var s:string);
function fpgmdirize(s:string):string;
function cwd:string;
function fcwdirize(s:string):string;

procedure deslash(var what:string);
procedure slash(var what:string);
function fslash(what:string):string;

function formatint(value:longint; size:integer):string;
function formathex(value:longint; size:integer):string;
function isdigit(c:char):boolean;
function isspace(c:char):boolean;
function ischar(c:char):boolean;
function isprint(c:char):boolean;
function hextoint(s:string):longint;
procedure intrange(low, high:integer; var what:integer);
procedure wordrange(low, high:word; var what:word);
procedure longrange(low,high:longint; var what:longint);
function hprintf(handle:integer; const TheFormat:string; const Args: array of
const):integer;
function hgets(handle:integer; var dst:string):boolean;
procedure tokenate(const s:string);
function tokenhget(handle:integer):boolean;
function boolstring(what:boolean):string;
function jgoStrToInt(const S: string): Longint;
function jgoi(const S: string; const start, count:integer):longint;
function spaces(count:integer):string;
procedure flip(var what:boolean);
function delineend(s:string):string;
function unline(s:string):string;
function extractname(const s:string):string;
function despace(const s:string):string;
function ipos(substr:string; index:integer; s:string):integer;
procedure removecharacter(var s:string; where:integer);
procedure addcharacter(var s:string; where:integer; what:char);

{ if count<>0, then initialize hung count; if 0, then return true if
counted down.}
function hung(count:integer):boolean;

function pixelbits:integer;
function lowest(one, two:integer):integer;
procedure switchint(var one, two: integer);
{procedure switchcase(var key:char);}
procedure makeupper(var key:char);
{ returns true if user answers yes. }
function usuref(
const TheFormat: string;
const Args:array of const):boolean;
function usure(s:string):boolean;

procedure errorf(
const TheFormat: string;
const Args:array of const;
clip:boolean = true); overload;

procedure errorf(
const TheFormat: string;
clip:boolean = true); overload;



function es(s:string; i:integer):char;
{used to be emptyspace}
procedure infof(
const TheFormat: string;
const Args:array of const);
function commaoid(s:string):string;
procedure colonoid(var s:string; var x:longint);
function ualphan(s:string):string;
procedure editselect(edit:tedit);
procedure replacechar(old,new:char; var dst:string);
function htell(handle:integer):longint;
function hrewind(handle:integer):boolean; {returns good if it worked.}
function firstselected(listbox:Tlistbox):integer;
function isdefault(s:string):boolean;
function hexoid(s:string):longint;
function lastchar(s:string; pos:integer = 1):string;
{returns value of first number in a string, i.e. "unit12" returns 12.}
function firstnumber(s:string):integer;
function uncontrol(var s:string):boolean;
function delayed(var t:TICKTIME; howlong: longint):boolean;
procedure mswait(ms: longint);
function getCDslash:string;

function mutoid(s:string):boolean;
{returns true if another mutex with string exists.}

procedure nfree(var what:Tobject);
procedure fontsize(s:string; f:Tfont; var width, height:integer);
function unquote(s:string):string;
procedure notimpl;
function quoteword(s:string):string;

{remove lower case from string.}
function unlower(s:string):string;

function ishex(c:char):boolean;
function ishexString(s:string):boolean;

function CompareStrN(const S1, S2: string; N:integer): Integer;
function CompareTextN(const S1, S2: string; N:integer): Integer;

function getaword(s:string):string;
function os_isw9x:boolean;
function os_isxp:boolean;

function safe_format(
const TheFormat: string;
const Args:array of const):string;

function jgo_slist:TStringList;
function jgo_slist_dups:TStringList;

procedure stupid_string_sort(List:TStringList; reverse:boolean = false;
casesensitive:boolean = false);

function stupid_find(List:TStringList; what:string; casecmp:boolean = false):
integer;
{var
printerheld:boolean; }

function stupid_compare(one,two:string; casecmp:boolean=false):integer;

procedure hcloseif(var h:integer);

function quotate(s:string; onlyif:boolean=false):string;

function JgoGetEnv(what:string):string;

function haspath(s:string):boolean;

type
file_kind = ( BATCH_kind, OTHER_kind );

function checkpath(what:string; debug:boolean = false):file_kind;
function pathlist:TStringList;
function x_in_path(what:string; debug:boolean = false):string;

procedure headtail(s:string; var head,tail:string);

function FileExists_unq(const FileName: string): Boolean;

function isbatch(what:string):boolean;

procedure hideInTaskBar;
procedure showInTaskBar;
function deblr(s:string):string;

function isfat32(s:string):boolean;
function driverut(apath:string):string;

const
TOKENCOUNT = 30;
TokenSize = 20;

var
tokenarray : array[1..TOKENCOUNT] of string;
tokens : integer;
tokenstr:string;    { the original string. }

implementation

uses SysUtils, clipbrd;


{--------------------------------------------------------------}
procedure quickbeep;
begin
  messagebeep($FFFF);
end;

function contexthelp(number:integer):boolean;
begin
  hglass;
  result :=
  Application.helpcommand(
  HELP_CONTEXT,
  number
  );
  dcursor;
end;

function helpoid(sHELPJUNK:pchar):boolean;
begin
  hglass;
  result :=
  Application.helpcommand(
  HELP_PARTIALKEY,
  longint(sHELPJUNK)
  );
  dcursor;
end;

{-----------------------------------------------------------}
procedure hglass;
begin
  screen.cursor := crHourGlass;
end;

procedure dcursor;
begin
  screen.cursor := crDefault;
end;

{-----------------------------------------------------------}

function itsinside(where:Tpoint; acontrol:TWinControl):
boolean;
begin
  result :=
  (where.x > acontrol.left) and
  (where.x < (acontrol.left+acontrol.width) ) and

  (where.y > acontrol.top) and
  (where.y < (acontrol.top + acontrol.height) );
end;

function TwinControlAtPos(where: Tpoint;
form:Tcomponent):TWinControl;
var
index : longint;
begin

  for index := 0 to
  form.componentcount-1 do begin
    if (form.components[index] is TWinControl)
    then begin
      result :=
      form.components[index] as TWinControl;
      if itsinside(where,result) then
      exit;
    end;
  end;

  result := nil;
end;

{Return a help context for the control, or if
no such, 0, or if acontrol is nil, 0.

Delphi documentation lies about presence of
helpcontext so we will cut 'n' try.
//so I found a chart on page 114,
*Developing Custom Delphi Components*, Konopka,
Coriolis, 1996 which seems to be helpful. I.e., a
TWinControl seems the most primitive thing with a
helpcontext. }

function TwinHelpContext(acontrol:TWinControl):
longint;
begin
  if (acontrol <> nil) then begin
    result := acontrol.helpcontext;
    exit;
  end;
  result := 0;
end;

function findhelp(form: Tform):boolean;
var
CurPos: Tpoint;
acontext : longint;

{column, row:integer; }

begin
  result := false;

  GetCursorPos(CurPos);
  CurPos := form.ScreenToClient(CurPos);

  acontext :=
  TwinHelpContext(
  TwinControlAtPos(CurPos,form as Tcomponent)
  );

  if (acontext <> 0) then begin
    result := true;
    contexthelp(acontext);
{    contexthelp(51); }
  end;

end;


{---------------------
HERE'S HOW IT'S USED:

procedure Twjnetform.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (key=vk_F1) then begin
    if (findhelp(wjnetform)) then begin

    [the form's key preview property must be true for this
    to work; but I thought I tried that six or seven times
    and it still didn't work. What *doesn't* seem to make
    a difference:
      form's showhint; it's false. IN WHRP it's true so.
      Application.HintPause := 1500;  // no diff
      Application.OnShowHint := DoShowHint; //nope.
    ]

      Key := 0;
    end;
  end;

end;

----------------------}

{-----------------------------------------}
procedure deslash(var what:string);
var i:integer;
begin
  i := length(what);
  if
//  what[i]='\'
  es(what,i)='\'
  then begin
{   what[0] := char(i - 1);  { they don't have a function! }
    setlength(what,i-1);
  end;
end;

procedure slash(var what:string);
begin
  deslash(what);
  what := what + '\';
end;

function fslash(what:string):string;
begin

  slash(what);
  result := what;

end;


procedure eslash(var what:string);
begin
  if length(what)>0 then
  slash(what);
end;

function pgmdir:string;
const
pgmd : string = '';
begin

  if length(pgmd)<1 then begin
    pgmd := ExtractFilePath(ParamStr(0));
    slash(pgmd);
  end;

  result := pgmd;

end;

function haspath(s:string):boolean;
begin
  result :=
  (pos('\',s)>0) or
  (pos(':',s)>0);
end;


procedure pgmdirize(var s:string);
begin

  if (length(s)>0) and
//  (pos('\',s)=0)
//  and (pos(':',s)=0)
  (not haspath(s))
  then

//  s := getCurrentDir+'\'+s;
  s := pgmdir+s;

end;

function fpgmdirize(s:string):string;
begin
  pgmdirize(s);
  result := s;
end;

{****************************************************************************
****************************************************************************}

function cwd:string;
const
cwd : string = '';
begin

  if length(cwd)<1 then begin
    cwd := GetCurrentDir;
    slash(cwd);
  end;

  result := cwd;

end;

function fcwdirize(s:string):string;
begin
  if (length(s)>0) and
//  (pos('\',s)=0)
//  and (pos(':',s)=0)
  (not haspath(s))
  then

//  s := getCurrentDir+'\'+s;
  s := cwd+s;

end;

{****************************************************************************
****************************************************************************}


procedure fixdirectory;
const
done : boolean = false;
var
directory:string;
begin
  if done then
  exit;

  done := true;
{ ExpandFileName ParamStr }
  directory := pgmdir;
  deslash(directory);
  { I think win3.1 aka dos6 whatever doesn't like
  the trailing slash? }
  try
    chdir(directory)
  except
    messagedlg(
    'Unscheduled error: chdir(' +
    directory +
    ') failed; sorry.',
    mtError,[mbOK],0);
  end;
  { try and use current directory. }
end;

{------------------------------------------------------------------------}

function formatint(value:longint; size:integer):string;
var i:integer;
begin
  result := safe_format('%*d',[size,value]);
  for i := 1 to length(result) do begin
    if result[i]=' ' then
    result[i] := '0';
  end;
end;

function formathex(value:longint; size:integer):string;
var i:integer;
begin
  result := safe_format('%*x',[size,value]);
  for i := 1 to length(result) do begin
    if result[i]=' ' then
    result[i] := '0';
  end;
end;

{---------------------------------------------------------------}
function isdigit(c:char):boolean;
begin
  result := false;
  case c of
    '0'..'9': result := true;
  end;
end;


{---------------------------------------------------------------}
function hextoint(s:string):longint;
var
i, anumber:integer;
begin
  result := 0;
  anumber := 0;

  for i:=1 to length(s) do begin
    case s[i] of
      '0'..'9': anumber := ord(s[i])-ord('0');
      'A'..'F': anumber := ord(s[i])-ord('A')+10;
      'a'..'f': anumber := ord(s[i])-ord('a')+10;
      else exit; {exit function at non-hex, i.e. like JgoStrToInt.}
    end;

    result := result*16;
    inc(result,anumber);
  end;
end;

{---------------------------------------------------------------}
procedure intrange(low, high:integer; var what:integer);
begin
  if (what < low) then what := low;
  if (what > high) then what := high;
end;

procedure wordrange(low, high:word; var what:word);
begin
  if (what < low) then what := low;
  if (what > high) then what := high;
end;

procedure longrange(low,high:longint; var what:longint);
begin
  if (what < low) then what := low;
  if (what > high) then what := high;
end;

{--------------------------------------------------------------}
function boolstring(what:boolean):string;
begin
  if (what) then
  result := 'true'
  else
  result := 'false';
end;




{****************************************************************************
****************************************************************************}


{$ifdef NADA_ESQYE}
//the little version.
{--------------------------------------------------------------}
function hprintf(handle:integer;
const TheFormat:string;
const Args: array of const):integer;
var
s:string;
p : array[0..257] of char;
count:integer;
begin

{
function StrPCopy(Dest: PChar; Source: string): PChar;
}
  result := -1;
  try
    s := safe_format(Theformat,args);
    count := length(s);
    StrPCopy(p,s);
    result := FileWrite(handle,p,count);
    if result<>count then
    result := -1;
  except
  end;
end;

{$endif}

{****************************************************************************
this is the BIG version.
function StrPLCopy(Dest: PChar; const Source: string; MaxLen: Cardinal): PChar;
****************************************************************************}

type brokenprintf_exception = class(EStreamError);

function hprintf(handle:integer;
const TheFormat:string;
const Args: array of const):integer;

const
ARSIZE = $200;

var
s:string;
slength:integer;

count:integer;
p : array[0..ARSIZE+5] of char;

begin

{
function StrPCopy(Dest: PChar; Source: string): PChar;
}
  result := -1;

  try
    s := safe_format(Theformat,args);
    slength := length(s);

    while true do begin
      count := length(s);

      if count>ARSIZE then
      count := ARSIZE;

      if count=0 then
      break;

      StrPLCopy(p,s,count);
      s := copy(s,count+1,slength);

      result := FileWrite(handle,p,count);
      if result<>count then
      raise
      brokenprintf_exception.Create(
      'hprintf result<>count failure');
    end;
    {this is the good end.}
    result := slength;
  except
    on e: exception do
    Errorf(e.message,[0]);
  end;

end;

{****************************************************************************
****************************************************************************}


{--------------------------------------------------------------}
function isspace(c:char):boolean;
begin
  result := false;
  case c of
    ' ', chr(9), chr(10), chr(13): result := true;
  end;
end;

function ischar(c:char):boolean;
begin
  result := not isspace(c);
end;

function isprint(c:char):boolean;
begin
  if c < ' ' then
  result := false
  else
  result := ischar(c);
end;

function despace(const s:string):string;
var
i:integer;
begin
  result := '';
  for i:=1 to length(s) do begin
    if not isspace(s[i]) then
    result := result + s[i];
  end;
end;

function ualphan(s:string):string;
var
i:integer;
begin
  result := '';
  for i:=1 to length(s) do begin
    case s[i] of
      'a'..'z','A'..'Z','0'..'9':
      result := result + UpCase(s[i]);
    end;
  end;
end;




{--------------------------------------------------------------}
{function FileRead(Handle: Integer; var Buffer; Count: Longint): Longint;}

function hgets(handle:integer; var dst:string):boolean;
var
c:char;
begin
  result := true;

  dst := '';

  while true do begin
    if FileRead(handle,c,1)<>1 then begin
      result := false;
      break;
    end;

    case c of
{stupid compiler doesn't like Cr constant !? }
      {Cr} chr(13): break;
      {LF} chr(10): ;       { throw away now. }
    else
      dst := dst+c;
      if (length(dst) >= 500) then
      break;
    end;
  end;
end;

function hrewind(handle:integer):boolean; {returns good if it worked.}
begin
  result :=
  (FileSeek(Handle, 0,0 )<> -1);
end;

function htell(handle:integer):longint;
begin
  result :=
  FileSeek(Handle,0,1);
end;

procedure tokenate(const s:string);
var
i:integer;
c:char;

state : (spaces, characters);

begin

  for i := low(tokenarray) to high(tokenarray) do
  tokenarray[i] := '';

  state := spaces;

  tokens := low(tokenarray)-1;  { pre decrement. }

  for i := 1 to length(s) do begin
    c := s[i];
    case state of
      spaces: begin
        if ischar(c) then begin
          state := characters;

          inc(tokens);
          tokenarray[tokens] := c;  {1st character.}

        end;
      end;

      characters: begin
        if isspace(c) then begin

          if tokens >= high(tokenarray) then
          break;

          state := spaces;

        end
        else
        tokenarray[tokens] := tokenarray[tokens]+c;
      end;
    end;
  end;

end;


{ tries to get a string from the handle, and then tokenates it,
leaving the results in the tokenarray, and the tokencount in tokens.
}

function tokenhget(handle:integer):boolean;
begin
  result := false;

  while true do begin

    if not hgets(handle,tokenstr) then
    exit;

    if (length(tokenstr)<1) or
    (tokenstr[1]=';') then
    continue;             { dump empty, comments }

    tokenate(tokenstr);
    break;
  end;

  result :=true;

end;

{-------------------------------------------------------------}

{same as StrToInt but doesn't crash at empty etc.}
function jgoStrToInt(const S: string): Longint;
var
i: integer;
minus : boolean;
r : longint;
begin
  r := 0;
  minus := false;

  for i := 1 to length(S) do begin
    case S[i] of
      ' ': ;  { throw away leading spaces }

      '0'..'9':
      r := (r * 10) + (ord(S[i])-ord('0'));

      '-':
      minus := true;

    else break;
    end
  end;

  result := r;

  if (minus) then
  result := -result;
end;


function jgoi(const S: string; const start, count:integer):longint;
begin
  result :=
  JgoStrToInt(copy(s,start,count));
end;


function spaces(count:integer):string;
begin
  result := '';
  while count>0 do begin
    result := result + ' ';
    dec(count);
  end;
end;

procedure flip(var what:boolean);
begin
  what := not what;
end;


{remove the last line end.}
function delineend(s:string):string;
var
count: integer;
begin
  count := length(s);
  if (count >= 2) and (s[count-1]=CR) then
  result := copy(s,1,count-2)
  else
  result := s;
end;

{remove bunches of last line ends}
function unline(s:string):string;
var
i:integer;
begin
  for i := 1 to 5 do
  s := delineend(s);
  result := s;
end;

function extractname(const s:string):string;
var
i:integer;
begin
  result := extractFileName(s);
  i := pos('.',result);
  if i>0 then
  result := copy(result,1,i-1);

end;


{return position in s of substr, but starting at index. 0 if not
there.}
function ipos(substr:string; index:integer; s:string):integer;
begin
  result := pos(substr,copy(s,index,255));
  if (result>0) then
  inc(result,index-1);
end;

{--------------------------------------------------------------}
procedure removecharacter(var s:string; where:integer);
begin
  if where>1 then
  s := copy(s,1,where-1)+copy(s,where+1,255)
  else
  s := copy(s,2,255);
end;

function hung(count:integer):boolean;
const
hungcount : integer = 0;
begin
  result := false;

  if count > 0 then
  hungcount := count
  else if hungcount=0 then
  result := true
  else begin
    dec(hungcount);
    if hungcount=0 then
    result := true;
  end;
end;

function pixelbits:integer;
var
ahandle : HDC;
begin
  ahandle:= CreateCompatibleDC(0);
  result := GetDeviceCaps(ahandle,BITSPIXEL);
  DeleteDC(ahandle);
end;

function lowest(one, two:integer):integer;
begin
  if (one < two) then
  result := one
  else
  result := two;
end;

procedure switchint(var one, two: integer);
var t : integer;
begin
  t := one;
  one := two;
  two := t;
end;

{
procedure switchcase(var key:char);
var
x:integer;
begin
  x := ord(key);
  case key of
    'A'..'Z': key := chr(x+$20);
    'a'..'z': key := chr(x-$20);
  end;
end;
}

procedure makeupper(var key:char);
var
x:integer;
begin
  x := ord(key);
  case key of
{    'A'..'Z': key := chr(x+$20);      }
    'a'..'z': key := chr(x-$20);
  end;
end;


function usure(s:string):boolean;
begin
  result :=
  MessageDlg(s,mtConfirmation,[mbYes,mbNo],0)
  = mrYES;
end;

procedure errorf(
const TheFormat: string;
const Args:array of const;
clip:boolean = true);
var
what:string;
begin
  what := safe_format(TheFormat,args);

  if clip then begin
    clipboard.astext := what;
    what := what + ' (clipped)';
  end;

  MessageDlg(what,mtError,[mbOK],0);
end;

procedure errorf(
const TheFormat: string;
clip:boolean = true); overload;
begin
  errorf(TheFormat, [0], clip);
end;


procedure infof(
const TheFormat: string;
const Args:array of const);
begin
  MessageDlg(safe_format(Theformat,args),mtInformation,[mbOK],0);
end;

function usuref(
const TheFormat: string;
const Args:array of const):boolean;
begin
  result := usure(safe_format(Theformat,args));
end;

{ returns s[i], but if that's empty, returns chr$(0). }
function es(s:string; i:integer):char;
begin
  if length(s)<i then
  result := chr(0)
  else
  result := s[i];
end;

{advance the string to the next comma argument}
function commaoid(s:string):string;
var
i:integer;
begin
  i := pos(',',s);
  if i > 0 then
  result := copy(s,i+1,500)
  else
  result := '';
end;

{ a utility procedure that extracts a value after a colon. If
s is "1234:45:987", colonoid will change s to "45:987" and set
x to 45. }
procedure colonoid(var s:string; var x:longint);
var i:integer;
begin
  i := pos(':',s);
  if i > 0 then begin
    s := copy(s,i+1,500);
    x := jgoStrToInt(s);
  end;
end;

procedure editselect(edit:TEdit);
begin
  edit.SelStart := 0;
  edit.SelLength := length(edit.text);
end;

procedure replacechar(old,new:char; var dst:string);
var
i:integer;
begin
  for i:=1 to length(dst) do begin
    if dst[i]=old then
    dst[i] := new;
  end;
end;


function firstselected(listbox:Tlistbox):integer;
var
i:integer;
begin
  result := 0;
  for i:=0 to listbox.items.count-1 do begin
    if listbox.selected[i] then begin
      result := i;
      exit;
    end;
  end;
end;

function isdefault(s:string):boolean;
begin
  result :=
  (CompareText('DEFAULT',s)=0);
end;

function hexoid(s:string):longint;
begin
  if ( (length(s)>0) and (s[1]='$') ) then
  result := HexToInt(copy(s,2,500))
  else
  result := JgoStrToInt(s);
end;

{ called like
nfree(Tobject(bingo)); }

procedure nfree(var what:Tobject);
begin
  what.free;
  what := nil;
end;

function lastchar(s:string; pos:integer = 1):string;
var
len:integer;
begin
  len := length(s)-(pos-1);

  if len > 0 then
  result := s[len]
  else
  result := chr(0);
end;

function firstnumber(s:string):integer;
var
i:integer;
begin
  result := 0;
  for i:= 1 to length(s) do begin
    if isdigit(s[i]) then begin
      result := JgoStrToInt(copy(s,i,500));
      exit;
    end;
  end;
end;

{***********************************************************************
removes control characters from s. Returns true if any such.
***********************************************************************}
function uncontrol(var s:string):boolean;
var
i:integer;
begin
  i := 1;
  result := false;

  while i <= length(s) do
  if (ord(s[i])<32) or (ord(s[i])>126) then begin
    s := copy(s,1,i-1)+copy(s,i+1,10000);
    result := true;
  end else
  inc(i);

end;

{****************************************************************************
if howlong, set wait to howlong. If 0, return YES if previous wait is
timed-out. Should be in ticks.// No u idiot in ms.
****************************************************************************}

function delayed(var t:TICKTIME; howlong: longint):boolean;
var
msnow : longint;
begin
  msnow := GetTickCount;  { that's a ms function. }

{ the allgorithm laughs at rollover, so don't need this...
  if (msnow <0) then begin
    result := true;
    exit;
  end;

Actually I suspect i could've just left it in there the way it is // right!
Except won't this stupid Pascal flag an error when it rolls-ver? Let's see.
//no. The way to do it is do the operation in the DLL of course. That's
why I have it. // well actuallly in the event is turned-out I *didn't* need
the DLL. sigh.
}

  if (howlong>0) then begin
    if (howlong < 60) then
    howlong := 60; {don't make it less than 55 i.e. xt tick ms.}
    t.oldcount := msnow;
    t.waitfor := howlong;
    result := false;
    exit;
  end;

  result :=
  (msnow-t.oldcount)
  >= t.waitfor;
end;

procedure mswait(ms: longint);
const
waiting:boolean = false;
var
t : TICKTIME;
begin
  if waiting then
  exit;

  waiting := true;
  if ms > 10000 then
  ms := 10000;

  delayed(t,ms);
  while not delayed(t,0) do
  begin
    application.processmessages;
  end;
  waiting := false;
end;


function getCDslash:string;
begin
  result := getCurrentDir;
  slash(result); //it might be d:\.
end;



procedure cwdize(var s:string);

begin

  if (length(s)>0) and (pos('\',s)=0)
  and (pos(':',s)=0) then
//  s := getCurrentDir+'\'+s;
  s := getCDslash+s;

end;

{returns true if another mutex with string exists. Or something.}

function mutoid(s:string):boolean;
var
  hMutex: Thandle;
begin
  HMutex := CreateMutex(nil,False,Pchar(s));

  result :=
  WaitForSingleObject(hMutex,0) = wait_Timeout;

end;

procedure fontsize(s:string; f:Tfont; var width, height:integer);
var
image : Timage;
begin
  image := Timage .create(nil);
  image.canvas.font := f;
  width := image.canvas.textwidth(s);
  height := image.canvas.textheight(s);
  image.free;

{this seemed to work Thursday, October 18, 2001 12:24 pm.
Tcanvas by itself "can't draw". // But note I couldn't use this
number to correctly decide how much junk would fit in a window by
dividing into height stormy weather. see lcx server.pas.}

end;

procedure addcharacter(var s:string; where:integer; what:char);
begin
  s :=
  copy(s,1,where-1)+
  what+
  copy(s,where,10000);
end;



{remove enclosing quotes.}
function unquote(s:string):string;
var
i:integer;
begin
  result := s;
  if es(result,1)='"' then
  result := copy(result,2,10000);

  if lastchar(result)='"' then
  result := copy(result,1,length(result)-1);

  while true do begin
    i := pos('""',result);

    if i<1 then
    exit;

    removecharacter(result,i);
  end;

end;

procedure notimpl;
begin
  errorf('Sorry; feature not implemented',[0]);
end;

{****************************************************************************
*If* the first character is a ", return the string without the enclosing
quotes. Otherwise, if the character is a non-blank, return the initial word.
Else return empty string. Note that this is double-quote, for use probably
with ini files or who knows.
****************************************************************************}

function quoteword(s:string):string;
var
i:integer;
begin
  result := '';

  if es(s,1)='"' then begin
    i := 2;
    while i<=length(s) do begin
      if s[i]='"' then begin
        if es(s,i+1)='"' then begin
          inc(i);
        end else
        exit; {with result == string.}
      end;

      result := result + s[i];
      inc(i);
    end;
    exit; {unterminated quote. Whatever.}
  end;

  if isspace(es(s,1)) then
  exit; {with empty result.}

  i := 1;

  while i<=length(s) do begin
    if isspace(s[i]) then
    exit;

    result := result+s[i];
    inc(i);
  end;

  {no space at end of word. Fall thru with result==word.}

end;

function unlower(s:string):string;
var
i:integer;
begin
  result := '';
  for i := 1 to length(s) do
  case s[i] of
    'a'..'z': ;
  else
    result := result + s[i];
  end;

end;

{****************************************************************************
         10        20
12345678901234567890123456789
ABCDEFGHIJKLMNOPQRSTUVWXYZ
    5

    12345678901234567890123456789
    EFGHIJKLMNOPQRSTUVWXYZ
          7

****************************************************************************}
function position(index:integer; what,s:string):integer;
begin
  result := pos(what,copy(s,index,5000));
  if result>0 then
  inc(result,index-1);
end;


function ishex(c:char):boolean;
begin
  result := false;
  case c of
    '0'..'9',
    'a'..'f',
    'A'..'F': result := true;
  end;
end;

function ishexString(s:string):boolean;
var
i:integer;
begin
  result := false;
  for i := 1 to length(s) do begin
    if not ishex(s[i]) then
    exit;
  end;

  result := true;

end;




{****************************************************************************
****************************************************************************}
function CompareStrN(const S1, S2: string; N:integer): Integer;
begin
  result := CompareStr(copy(s1,1,n),copy(s2,1,n));
end;

function CompareTextN(const S1, S2: string; N:integer): Integer;
begin
  result := CompareText(copy(s1,1,n),copy(s2,1,n));
end;

{****************************************************************************
****************************************************************************}

function getaword(s:string):string;
var
i:integer;
begin
  result := '';
  for i := 1 to length(s) do begin
    if (s[i]=' ') then begin
      if (length(result)>0) then
      exit;
    end else
    result := result + s[i];
  end;
end;

{****************************************************************************
****************************************************************************}
function os_isxp:boolean;
begin
  result := not os_isw9x;
end;


function os_isw9x:boolean;
var
OSVersionInfo: TOSVersionInfo;
begin
  result := true;   {assume w9x.}

  OSVersionInfo.szCSDVersion[0] := chr(0);
  OSVersionInfo.dwOSVersionInfoSize := SizeOf(OSVersionInfo);
  if (not GetVersionEx(OSVersionInfo)) then
  exit;

  {
  osinfof('Windows version %d.%d',
  [OSVersionInfo.dwMajorVersion,OSVersionInfo.dwMinorversion]);
  }

  if OSVersionInfo.dwMajorVersion>=5 then
  result := false;


end;

{****************************************************************************
****************************************************************************}
function safe_format(
const TheFormat: string;
const Args:array of const):string;
begin
  try
    result := format(Theformat,args);
  except
    on e: exception do
    result :=
    format('Format() error in program!'+LNEND+'Error:'+LNEND+'%s'+LNEND+
    'Format:'+LNEND+'%s',[e.message,TheFormat]);
  end;
end;

{****************************************************************************
****************************************************************************}
function jgo_slist:TStringList;
begin
  result := TStringList.create;
  result.sorted := false;
//  result.casesensitive := false;
  result.duplicates := dupError {dupAccept};
end;

function jgo_slist_dups:TStringList;
begin
  result := TStringList.create;
  result.sorted := false;
//  result.casesensitive := false;
  result.duplicates := dupAccept;
//although apparently pays no attention to the parameter anyway....
end;

{****************************************************************************
The callback returns

a value less than 0 if the string identified by Index1 comes before the string
identified by Index2

0 if the two strings are equivalent

a value greater than 0 if the string with Index1 comes after the string
identified by Index2.

****************************************************************************}

function custom_compare(List: TStringList; Index1, Index2: Integer): Integer;
begin
  result := CompareText(list[Index1],list[Index2]);
end;


function custom_case(List: TStringList; Index1, Index2: Integer): Integer;
begin
  result := CompareStr(list[Index1],list[Index2])
end;


function r_custom_compare(List: TStringList; Index1, Index2: Integer): Integer;
begin
  result := CompareText(list[Index2],list[Index1]);
end;


function r_custom_case(List: TStringList; Index1, Index2: Integer): Integer;
begin
  result := CompareStr(list[Index2],list[Index1])
end;



procedure stupid_string_sort(List:TStringList; reverse:boolean = false;
casesensitive:boolean = false);
begin
  if reverse then begin

    if casesensitive then
    List.customsort(r_custom_case)
    else
    List.customsort(r_custom_compare);

  end else begin

    if casesensitive then
    List.customsort(custom_case)
    else
    List.customsort(custom_compare);

  end;

end;

function stupid_compare(one,two:string; casecmp:boolean=false):integer;
begin
  if casecmp then
  result := comparestr(one,two)
  else
  result := comparetext(one,two);
end;

function stupid_find(List:TStringList; what:string; casecmp:boolean = false):
integer;
var
i:integer;
begin
  result := -1;

  if casecmp then
  for i := 0 to list.count-1 do begin
    if list[i]=what then begin
      result := i;
      exit;
    end;
  end
  else
  for i := 0 to list.count-1 do begin
    if comparetext(list[i],what)=0 then begin
      result := i;
      exit;
    end;
  end

end;

procedure hcloseif(var h:integer);
begin
  if h>=0 then begin
    FileClose(h);
  end;
  h := -1;
end;


{****************************************************************************
****************************************************************************}

{fix quotes and add enclosing quotes.}
function quotate(s:string; onlyif:boolean=false):string;
var
i:integer;
begin
  result := s;

  i := 1;

//only bother with things that have spaces and don't start with a quote
//already.
  if onlyif
  and (pos(' ',s)<1)
  and (es(s,1)<>'"')
  then
  exit;

  while i <= length(result) do begin
    if result[i]='"' then begin
      addcharacter(result,i,'"');
      inc(i,2);
    end else
    inc(i);
  end;

  result := '"' + result + '"';

end;

{****************************************************************************
****************************************************************************}
{$ifdef VER130} //delphi5.

{$define USEGETMEM}

{$ifdef USEGETMEM}

function JgoGetEnv(what:string):string;
const
SLOP = 5;
LT_SLOP = 3;
var
whatever : PCHAR;
test : array[0..2] of char;
returned_size,
allocate_size : integer;
begin

  result := '';

  returned_size := GetEnvironmentVariable(Pchar(what),@test,0);
{****************************************************************************
Thu 8/31/2006 11:52 am. See it returns the *number of characters* supposedly;
or it does on odd-numbered Tuesdays. I believe *if error* it's supposed to
return number of characters + terminator, but if everything's OK, it returns
number of characters. We'll assume the worst, and deliberately allocate more
memory,
****************************************************************************}

  if returned_size=0 then
  exit;

  allocate_size := returned_size + SLOP;

  GetMem(whatever,allocate_size);
  GetEnvironmentVariable(Pchar(what),whatever,returned_size+LT_SLOP);
//  s := whatever;
  result := whatever;
  FreeMem(whatever,allocate_size);

end;

{$else}

function JgoGetEnv(what:string):string;
const
PATHSIZE = 2000;
var
whatever: array[0..PATHSIZE+5] of char;
begin
  GetEnvironmentVariable(Pchar(what),@whatever,PATHSIZE-4);
  result := whatever;
end;

{$endif}  //usegetmem

{$endif}  //ver130.


{$ifdef VER150} //delphi7 probably.

function JgoGetEnv(what:string):string;
begin
  result := GetEnvironmentVariable(what);
end;

{$endif}

{****************************************************************************
returns a stringlist of slash-terminated paths.
you gotta free the result.
****************************************************************************}
function pathlist:TStringList;
const
sep =
//{$ifdef MSWINDOWS}
';'
//{$endif}
//{$ifdef LINUX}
//':'
//{$endif}
;
var
s, thepath:string;
i : integer;

procedure addpath_if;
begin
  if s='' then
  exit;

  s := unquote(s);  //Tue 9/26/2006 1:03 pm. bad quotes.

  slash(s);
  result.add(s);

  s := '';

end;

begin
  result := jgo_slist;

  thepath := JgoGetEnv('PATH');

  s := '.';             //start with the local path.
  addpath_if;
//  result.add('');         //just use nothing instead.
//no that would wander in the path maybe.

  for i := 1 to length(thepath) do begin
    if thepath[i]=sep then begin
      addpath_if;
    end else begin
      s := s + thepath[i];
    end;
  end;

  addpath_if;      //trailing path?

end;


{****************************************************************************
        so according to exec in Turbo C library, the order is

     no search path for file as-is //don't do this one.

        search path for .com
                        .exe

      And according to my experiments, THEN we look for
                        .bat
                        .cmd

  Whatever.

Should return full path -- or if unfound, original string.

But let's look for them in each path directory in the above order; instead of
going through the whole thing in order, which is obviously wrong.

****************************************************************************}

function x_in_path(what:string; debug:boolean = false):string;
var
extensions,
paths : TStringList;
label
GOODNESS,
BADNESS;

  function pathoid:boolean;
  var
  i,j:integer;
  begin

    result := true;     //assume success.

    for i := 0 to paths.count-1 do
    for j := 0 to extensions.count-1 do begin
      if FileExists(paths[i]+what+extensions[j]) then begin
        x_in_path := quotate(paths[i]+what+extensions[j],true);
        //set enclosing result probably.

        if debug then
        infof('x_in_path: %s',[paths[i]+what+extensions[j]]);
        exit;
      end;

    end;

    result := false;    //failure.

  end;

begin

  if haspath(what)
  and fileexists(what) then begin
//already accessible. Or at least there's no point in sticking paths in front
//of it.
    result := what;
    exit;
  end;

  paths := pathlist;
  extensions := jgo_slist;

//already has an extension.
  if ExtractFileExt(what)<>'' then begin
    extensions.add('');
    if pathoid then
    goto GOODNESS;

    goto BADNESS;
  end;

  extensions.clear;
  extensions.add('.com');
  extensions.add('.exe');
  extensions.add('.bat');
  if os_isxp then
  extensions.add('.cmd');

  if pathoid then
  goto GOODNESS;

BADNESS:
  result := what;

GOODNESS:
  freeandnil(paths);
  freeandnil(extensions);
end;

{****************************************************************************
****************************************************************************}


function checkpath(what:string; debug:boolean = false):file_kind;
var
s : string;
begin
  if not FileExists(what) then
  what := x_in_path(what,debug);

  s := ExtractFileExt(what);

  if SameText(s,'.bat')
  or SameText(s,'.cmd')
  then
  result := BATCH_kind
  else
  result := OTHER_kind;

end;
{****************************************************************************
****************************************************************************}

procedure headtail(s:string; var head,tail:string);
var
sl:TStringList;

  procedure requotify;
  var
  index, index2:integer;
  begin

//actually I only have to requotify the first one.

    index := pos(sl[0],s);
    if (index<2)          //we're looking for a quote *ahead* of it.
    or (s[index-1]<>'"')  //not a quote.
    then
    exit;                 //all is well.

//the thing was quoted.
    index2 := ipos('"',index+1,s);

    if index2<1 then
    exit;                 //to heck with it.

{****************************************************************************
  123456
  "abcd"

  6-1 ==>5.
****************************************************************************}

    sl[0] := copy(s,index-1,index2-index+2);

  end;

begin
  sl := jgo_slist;

  sl.commatext := s;

  requotify;

  head := sl[0];

  tail := copy(s,length(head)+1,5000);

  freeandnil(sl);

end;



{****************************************************************************
****************************************************************************}

function FileExists_unq(const FileName: string): Boolean;
begin
  result :=
  FileExists(unquote(FileName));
end;

{****************************************************************************
****************************************************************************}
function isbatch(what:string):boolean;
var
s:string;
begin

  s := ExtractFileExt(unquote(what));

  result :=
  (SameText(s,'.bat'))
  or
  ((os_isxp) and SameText(s,'.cmd'))
  ;

end;

{****************************************************************************
delphi5 versions for numbercommas; also have to change numbercommas type from
uint64 to Cardinal.
****************************************************************************}
function rightstr(s:string; n:integer):string;
begin
  result := copy(s,(length(s)-n)+1,n);
end;

function leftstr(s:string; n:integer):string;
begin
  result := copy(s,1,n);
end;


{****************************************************************************
****************************************************************************}

function numbercommas(x:cardinal):string;
var
s, three:string;

begin
  s := IntToStr(x);
  result := '';

  while true do begin

    three :=
    rightstr(s,3)
    ;

    s := leftstr(s, length(s)-3);

    if length(s)>0 then
    result := ','+three+result
    else begin
      result := three+result;
      break;
    end;

  end;

end;

{****************************************************************************
****************************************************************************}
procedure hideInTaskBar;
begin
//has not effect if called in create.
  ShowWindow(Application.handle,SW_HIDE);
end;

procedure showInTaskBar;
begin
  ShowWindow(Application.handle,SW_SHOW);
end;

procedure showTaskBar;
begin
  ShowWindow(FindWindow
  ('Shell_TrayWnd',nil), SW_SHOWNA) ;
end;

procedure hideTaskBar;
begin
  ShowWindow(FindWindow
  ('Shell_TrayWnd',nil), SW_HIDE) ;
end;

{****************************************************************************
****************************************************************************}

function deblr(s:string):string;
var
i:integer;
begin
  for i := 1 to length(s) do begin
    if s[i]='_' then
    s[i] := ' ';
  end;
  result := s;
end;




{****************************************************************************
BOOL GetVolumeInformation(

    LPCTSTR lpRootPathName,     // address of root directory of the file system
    LPTSTR lpVolumeNameBuffer,  // address of name of the volume
    DWORD nVolumeNameSize,      // length of lpVolumeNameBuffer
    LPDWORD lpVolumeSerialNumber,       // address of volume serial number
    LPDWORD lpMaximumComponentLength,   // address of system's maximum filename length
    LPDWORD lpFileSystemFlags,  // address of file system flags
    LPTSTR lpFileSystemNameBuffer,      // address of name of file system
    DWORD nFileSystemNameSize   // length of lpFileSystemNameBuffer
   );

Parameters

  lpRootPathName

  Points to a string that contains the root directory of the volume to be
  described. If this parameter is NULL, the root of the current directory is
  used. If this parameter is a UNC name, you must follow it with an additional
  backslash. For example, you would specify \\MyServer\MyShare as
  \\MyServer\MyShare\.

  lpVolumeNameBuffer

  Points to a buffer that receives the name of the specified volume.

  nVolumeNameSize

  Specifies the length, in characters, of the volume name buffer. This
  parameter is ignored if the volume name buffer is not supplied.

  lpVolumeSerialNumber

  Points to a variable that receives the volume serial number. This parameter
  can be NULL if the serial number is not required.

  lpMaximumComponentLength

  Points to a doubleword value that receives the maximum length, in
  characters, of a filename component supported by the specified file system.
  A filename component is that portion of a filename between backslashes. The
  value stored in variable pointed to by *lpMaximumComponentLength is used to
  indicate that long names are supported by the specified file system. For
  example, for a FAT file system supporting long names, the function stores
  the value 255, rather than the previous 8.3 indicator. Long names can also
  be supported on systems that use the New Technology file system.

  lpFileSystemFlags

  Points to a doubleword that receives flags associated with the specified
  file system. This parameter can be any combination of the following flags,
  with one exception: FS_FILE_COMPRESSION and FS_VOL_IS_COMPRESSED are
  mutually exclusive.

  Value                   Meaning

  FS_CASE_IS_PRESERVED    If this flag is set, the file system preserves the
  case of filenames when it places a name on disk.

  FS_CASE_SENSITIVE       If this flag is set, the file system supports
  case-sensitive filenames.

  FS_UNICODE_STORED_ON_DISK       If this flag is set, the file system
  supports Unicode in filenames as they appear on disk.

  FS_PERSISTENT_ACLS      If this flag is set, the file system preserves and
  enforces ACLs. For example, NTFS preserves and enforces ACLs, and FAT does
  not.

  FS_FILE_COMPRESSION     The file system supports file-based compression.


  FS_VOL_IS_COMPRESSED    The specified volume is a compressed volume; for
  example, a DoubleSpace volume.


  lpFileSystemNameBuffer

  Points to a buffer that receives the name of the file system (such as FAT or
  NTFS).

  nFileSystemNameSize

  Specifies the length, in characters, of the file system name buffer. This
  parameter is ignored if the file system name buffer is not supplied.

Return Values

  If all the requested information is retrieved, the return value is nonzero.

  If not all the requested information is retrieved, the return value is zero.
  To get extended error information, call GetLastError.

Tue 3/03/2009 4:28 pm. The above was useless;
http://www.delphicorner.f9.co.uk/articles/wapi2.htm had a nice example
however, which I've stolen.

****************************************************************************}


function isfat32(s:string):boolean;
var
  //Volume Information Variables
  nVNameSer   : PDWORD;
  drv         : String;
  pVolName    : PChar;
  FSSysFlags,
  maxCmpLen   : DWord;
//  I           : Integer;
  pFSBuf       : PChar;

//  r : boolean;
  FSbuf:string;

begin
//  result := false;

  drv := driverut(s);
//  drv := 'n:\';

  GetMem(pVolName, MAX_PATH);
  GetMem(pFSBuf, MAX_PATH);
  GetMem(nVNameSer, MAX_PATH);

//  r :=
  GetVolumeInformation(PChar(drv), pVolName, MAX_PATH, nVNameSer,
                       maxCmpLen, FSSysFlags, pFSBuf, MAX_PATH);

  FSBuf := StrPas(pFSBuf);

  FreeMem(pVolName, MAX_PATH);
  FreeMem(pFSBuf, MAX_PATH);
  FreeMem(nVNameSer, MAX_PATH);

//  result := r;
  result := pos('FAT32',UpperCase(FSbuf))>0;


end;

function driverut(apath:string):string;
var
i:integer;
begin

  i := pos(':',apath);
  if i<1 then begin
    result := driverut(GetCurrentDir);
    exit;
  end;

  result := copy(apath,1,i+1);

end;



end.
